#include "MAX7456OSD.H" 
#include <EEPROM.h>
#define DATAOUT 		11	  // MOSI
#define DATAIN 			12	  // MISO
#define SPICLOCK 		13	  // SCK
#define MAX7456SELECT 		6         // SS 
#define MAX7456RESET 		10 
int bat1 = A2;

int button = 0;
int cursorx = 2;
int cursory = 1;
int menuoption = 0; //menu
int mainmenurow = 0; //osdmenu
int textenable[]={0, 0, 0, 0, 0, 0, 0}; //osdmenu
int rowselect1[]={0, 0, 0, 0, 0, 0, 0}; //osdmenu
int rowselect2[]={0, 0, 0, 0, 0, 0, 0}; //osdmenu
int rowselect3[]={0, 0, 0, 0, 0, 0, 0}; //osdmenu
int rowselect4[]={0, 0, 0, 0, 0, 0, 0}; //osdmenu
int blinkenable[]={0, 0, 0, 0, 0, 0, 0}; //osdmenu
int colorselect[]={0, 0, 0, 0, 0, 0, 0}; //osdmenu
int row = 0; //osdmenu
int textnumber = 0; //osdmenu 
int characterpos = 0; //edittext
int editxpos = 0; //editmenu
int xpos[]={0, 0, 0, 0, 0, 0, 0}; //posedit
int ypos[]={0, 0, 0, 0, 0, 0, 0}; //posedit
int loopxpos[]={0, 0, 0, 0, 0, 0, 0}; //posedit
const char* availablecharacters[]={" ", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", " ", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "/", "(", ")", ".", ",", ":", ";", "'", "@", " ","A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"};
int text0[]={0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; //edittest
int text1[]={0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; //edittest
int text2[]={0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; //edittest
int text3[]={0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; //edittest
int text4[]={0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; //edittest
int text5[]={0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; //edittest
long previousMillis = 0;

void Max7456() {
  spi_transfer(VM0_reg);
  spi_transfer(VERTICAL_SYNC_NEXT_VSYNC|OSD_ENABLE|SYNC_MODE_AUTO);
  digitalWrite(MAX7456SELECT,HIGH); 
}

byte convert_ascii (int character) {
 byte lookup_char;
  if (character == 32) lookup_char = 0x00;
  else if (character == 48) lookup_char = 0x0a; 
  else if ((character > 48) && (character < 58)) lookup_char = (character - 48); 
  else if ((character > 64) && (character < 91)) lookup_char = (character - 54); 
  else if ((character > 96) && (character < 123)) lookup_char = (character - 60);
  else if (character == 34) lookup_char = 0x48; 
  else if (character == 39) lookup_char = 0x46; 
  else if (character == 40) lookup_char = 0x3f; 
  else if (character == 41) lookup_char = 0x40; 
  else if (character == 44) lookup_char = 0x45;
  else if (character == 45) lookup_char = 0x49; 
  else if (character == 46) lookup_char = 0x41; 
  else if (character == 47) lookup_char = 0x47;
  else if (character == 58) lookup_char = 0x44; 
  else if (character == 59) lookup_char = 0x43; 
  else if (character == 60) lookup_char = 0x4a; 
  else if (character == 62) lookup_char = 0x4b;
  else if (character == 63) lookup_char = 0x42; 
  else if (character == 64) lookup_char = 0x4c; 
  else lookup_char = 0x00; 
 return (lookup_char);
}

void OSD_Clear() {
  digitalWrite(MAX7456SELECT,LOW);
  spi_transfer(DMM_reg);
  spi_transfer(CLEAR_display);      
  digitalWrite(MAX7456SELECT,HIGH);
}

void OSD_write_to_screen(const char s[], byte x, byte y, byte blink, byte invert) {
  unsigned int linepos;
  byte local_count;
  byte settings, char_address_hi, char_address_lo;
  byte screen_char;
  local_count = 0;
  char_address_hi = 0;
  char_address_lo = 0;
  linepos = y*30+x;
  char_address_hi = linepos >> 8;
  char_address_lo = linepos;
  settings = B00000001;
  if (blink) settings |= (1 << 4);
  if (invert) settings |= (1 << 3);	 
  digitalWrite(MAX7456SELECT,LOW);
  spi_transfer(DMM_reg);        
  spi_transfer(settings);
  spi_transfer(DMAH_reg);        
  spi_transfer(char_address_hi);
  spi_transfer(DMAL_reg);       
  spi_transfer(char_address_lo);
  while(s[local_count]!='\0') {
    screen_char = s[local_count];
    screen_char= convert_ascii(screen_char);
    spi_transfer(DMDI_reg);
    spi_transfer(screen_char);
    local_count++;
  }
  spi_transfer(DMDI_reg);
  spi_transfer(END_string);
  spi_transfer(VM0_reg); 
  spi_transfer(ENABLE_display_vert);
  digitalWrite(MAX7456SELECT,HIGH);
}

void spi_writereg(byte r, byte d) {
  spi_transfer(r);
  spi_transfer(d);
}  

byte spi_transfer(volatile byte data) {
  SPDR = data;			  
  while (!(SPSR & (1<<SPIF)));
  return SPDR;			
}

void eepromcheck() {
  long addres1022 = EEPROM.read(1022);
  long addres1023 = EEPROM.read(1023);
  if (addres1022 != 165 || addres1023 != 165) {
    Serial.println("clearing eeprom");
    for (int address = 0; address < 1024; address++) {
      EEPROM.write(address, 0);
    }
    EEPROM.write(1022, 165);
    EEPROM.write(1023, 165);
  }
}
void writetext0toeeprom() {
  long eepromadress = 0;
  for (int letter = 0; letter < 25; letter++) {
    EEPROM.write(eepromadress, text0[letter]);
    eepromadress ++;
  }
}
void readtext0fromeeprom() {
  long eepromadress = 0;
  for (int letter = 0; letter < 25; letter++) {
    long temptext = EEPROM.read(eepromadress);
    text0[letter] = temptext;
    eepromadress ++;
  }
}
void writetext1toeeprom() {
  long eepromadress = 30;
  for (int letter = 0; letter < 25; letter++) {
    EEPROM.write(eepromadress, text1[letter]);
    eepromadress ++;
  }
}
void readtext1fromeeprom() {
  long eepromadress = 30;
  for (int letter = 0; letter < 25; letter++) {
    long temptext = EEPROM.read(eepromadress);
    text1[letter] = temptext;
    eepromadress ++;
  }
}
void writetext2toeeprom() {
  long eepromadress = 60;
  for (int letter = 0; letter < 25; letter++) {
    EEPROM.write(eepromadress, text2[letter]);
    eepromadress ++;
  }
}
void readtext2fromeeprom() {
  long eepromadress = 60;
  for (int letter = 0; letter < 25; letter++) {
    long temptext = EEPROM.read(eepromadress);
    text2[letter] = temptext;
    eepromadress ++;
  }
}
void writetext3toeeprom() {
  long eepromadress = 90;
  for (int letter = 0; letter < 25; letter++) {
    EEPROM.write(eepromadress, text3[letter]);
    eepromadress ++;
  }
}
void readtext3fromeeprom() {
  long eepromadress = 90;
  for (int letter = 0; letter < 25; letter++) {
    long temptext = EEPROM.read(eepromadress);
    text3[letter] = temptext;
    eepromadress ++;
  }
}
void writetext4toeeprom() {
  long eepromadress = 120;
  for (int letter = 0; letter < 25; letter++) {
    EEPROM.write(eepromadress, text4[letter]);
    eepromadress ++;
  }
}
void readtext4fromeeprom() {
  long eepromadress = 120;
  for (int letter = 0; letter < 25; letter++) {
    long temptext = EEPROM.read(eepromadress);
    text4[letter] = temptext;
    eepromadress ++;
  }
}
void writetext5toeeprom() {
  long eepromadress = 150;
  for (int letter = 0; letter < 25; letter++) {
    EEPROM.write(eepromadress, text5[letter]);
    eepromadress ++;
  }
}
void readtext5fromeeprom() {
  long eepromadress = 150;
  for (int letter = 0; letter < 25; letter++) {
    long temptext = EEPROM.read(eepromadress);
    text5[letter] = temptext;
    eepromadress ++;
  }
}
void writetextenabletoeeprom() {
  long eepromadress = 180;
  for (int letter = 0; letter < 6; letter++) {
    EEPROM.write(eepromadress, textenable[letter]);
    eepromadress ++;
  }
}
void readtextenablefromeeprom() {
  long eepromadress = 180;
  for (int letter = 0; letter < 6; letter++) {
    long temptext = EEPROM.read(eepromadress);
    textenable[letter] = temptext;
    eepromadress ++;
  }
}
void writeblinkenabletoeeprom() {
  long eepromadress = 190;
  for (int letter = 0; letter < 6; letter++) {
    EEPROM.write(eepromadress, blinkenable[letter]);
    eepromadress ++;
  }
}
void readblinkenablefromeeprom() {
  long eepromadress = 190;
  for (int letter = 0; letter < 6; letter++) {
    long temptext = EEPROM.read(eepromadress);
    blinkenable[letter] = temptext;
    eepromadress ++;
  }
}
void writecolorselecttoeeprom() {
  long eepromadress = 200;
  for (int letter = 0; letter < 6; letter++) {
    EEPROM.write(eepromadress, colorselect[letter]);
    eepromadress ++;
  }
}
void readcolorselectfromeeprom() {
  long eepromadress = 200;
  for (int letter = 0; letter < 6; letter++) {
    long temptext = EEPROM.read(eepromadress);
    colorselect[letter] = temptext;
    eepromadress ++;
  }
}
void writexpostoeeprom() {
  long eepromadress = 210;
  for (int letter = 0; letter < 6; letter++) {
    EEPROM.write(eepromadress, xpos[letter]);
    eepromadress ++;
  }
}
void readxposfromeeprom() {
  long eepromadress = 210;
  for (int letter = 0; letter < 6; letter++) {
    long temptext = EEPROM.read(eepromadress);
    xpos[letter] = temptext;
    eepromadress ++;
  }
}
void writeypostoeeprom() {
  long eepromadress = 220;
  for (int letter = 0; letter < 6; letter++) {
    EEPROM.write(eepromadress, ypos[letter]);
    eepromadress ++;
  }
}

void readyposfromeeprom() {
  long eepromadress = 220;
  for (int letter = 0; letter < 6; letter++) {
    long temptext = EEPROM.read(eepromadress);
    ypos[letter] = temptext;
    eepromadress ++;
  }
}
void writeloopxpostoeeprom() {
  long eepromadress = 230;
  for (int letter = 0; letter < 6; letter++) {
    EEPROM.write(eepromadress, loopxpos[letter]);
    eepromadress ++;
  }
}
void readloopxposfromeeprom() {
  long eepromadress = 230;
  for (int letter = 0; letter < 6; letter++) {
    long temptext = EEPROM.read(eepromadress);
    loopxpos[letter] = temptext;
    eepromadress ++;
  }
}

void menu() {
  if (menuoption == 0) showtext();
  if (menuoption == 1) osdmenu();
  if (menuoption == 2) slowshowtext();
  if (menuoption == 10) edittext0();
  if (menuoption == 11) edittext1();
  if (menuoption == 12) edittext2();
  if (menuoption == 13) edittext3();
  if (menuoption == 14) edittext4();
  if (menuoption == 15) edittext5();
  if (menuoption == 20) movecursor();
}


void readbuttons() {
  int pinread = analogRead(bat1);
  if (pinread > 5) {
    button = 1;
    if (pinread > 20) button = 2;
    if (pinread > 25) button = 3;
    if (pinread > 50) button = 4;
    if (pinread > 60) button = 5;
    delay(100);
  }
  else button = 0;
}

void showtext() {
  for (int i = 0; i < 25; i++) {
    if (textenable[0]== 1 && text0[i] != 0 && text0[i] != 27 && text0[i] != 47)  OSD_write_to_screen(availablecharacters[text0[i]],xpos[0] + i,ypos[0],blinkenable[0],colorselect[0]);
    if (textenable[1]== 1 && text1[i] != 0 && text1[i] != 27 && text1[i] != 47)  OSD_write_to_screen(availablecharacters[text1[i]],xpos[1] + i,ypos[1],blinkenable[1],colorselect[1]);
    if (textenable[2]== 1 && text2[i] != 0 && text2[i] != 27 && text2[i] != 47)  OSD_write_to_screen(availablecharacters[text2[i]],xpos[2] + i,ypos[2],blinkenable[2],colorselect[2]);
    if (textenable[3]== 1 && text3[i] != 0 && text3[i] != 27 && text3[i] != 47)  OSD_write_to_screen(availablecharacters[text3[i]],xpos[3] + i,ypos[3],blinkenable[3],colorselect[3]);
    if (textenable[4]== 1 && text4[i] != 0 && text4[i] != 27 && text4[i] != 47)  OSD_write_to_screen(availablecharacters[text4[i]],xpos[4] + i,ypos[4],blinkenable[4],colorselect[4]);
    if (textenable[5]== 1 && text5[i] != 0 && text5[i] != 27 && text5[i] != 47)  OSD_write_to_screen(availablecharacters[text5[i]],xpos[5] + i,ypos[5],blinkenable[5],colorselect[5]);
  }
  menuoption = 2;
}

void slowshowtext() {
  unsigned long currentMillis = millis();
  if(currentMillis - previousMillis > 10000) {
    for (int i = 0; i < 25; i++) {
      if (textenable[0]== 1 && text0[i] != 0 && text0[i] != 27 && text0[i] != 47)  OSD_write_to_screen(availablecharacters[text0[i]],xpos[0] + i,ypos[0],blinkenable[0],colorselect[0]);
      if (textenable[1]== 1 && text1[i] != 0 && text1[i] != 27 && text1[i] != 47)  OSD_write_to_screen(availablecharacters[text1[i]],xpos[1] + i,ypos[1],blinkenable[1],colorselect[1]);
      if (textenable[2]== 1 && text2[i] != 0 && text2[i] != 27 && text2[i] != 47)  OSD_write_to_screen(availablecharacters[text2[i]],xpos[2] + i,ypos[2],blinkenable[2],colorselect[2]);
      if (textenable[3]== 1 && text3[i] != 0 && text3[i] != 27 && text3[i] != 47)  OSD_write_to_screen(availablecharacters[text3[i]],xpos[3] + i,ypos[3],blinkenable[3],colorselect[3]);
      if (textenable[4]== 1 && text4[i] != 0 && text4[i] != 27 && text4[i] != 47)  OSD_write_to_screen(availablecharacters[text4[i]],xpos[4] + i,ypos[4],blinkenable[4],colorselect[4]);
      if (textenable[5]== 1 && text5[i] != 0 && text5[i] != 27 && text5[i] != 47)  OSD_write_to_screen(availablecharacters[text5[i]],xpos[5] + i,ypos[5],blinkenable[5],colorselect[5]);
      previousMillis = currentMillis;
    }
  }
  if (button == 5) {
    OSD_Clear();
    button = 0;
    menuoption = 1;
  }
  delay(100);
}

void osdmenu() {
  if (button == 4) {
    rowselect1[row] = 0;
    rowselect2[row] = 0;
    rowselect3[row] = 0;
    rowselect4[row] = 0;
    mainmenurow--;
  }
  if (button == 2) {
    rowselect1[row] = 0;
    rowselect2[row] = 0;
    rowselect3[row] = 0;
    rowselect4[row] = 0;
    mainmenurow++;
  }
  if (mainmenurow < 0) mainmenurow = 3;
  if (mainmenurow > 3) mainmenurow = 0;
  if (mainmenurow == 0) {
    if (button == 1) {
      rowselect1[row] = 0;
      row--;
    }
    if (button == 3) {
      rowselect1[row] = 0;
      row++;
    }
    if (row < 0) row = 6;
    if (row > 6) row = 0;
    rowselect1[row] = 1; 
    if (button == 5) textenable[row]++;
    if (textenable[row] > 1) textenable[row] = 0;
  }
  if (mainmenurow == 1) {
    if (button == 1) {
      rowselect2[row] = 0;
      row--;
    }
    if (button == 3) {
      rowselect2[row] = 0;
      row++;
    }
    if (row < 0) row = 6;
    if (row > 6) row = 0;
    rowselect2[row] = 1;
    if (button == 5 && row < 6) {
      button = 0;
      rowselect2[row] = 0;
      editxpos = 0;
      writetextenabletoeeprom(); 
      writeblinkenabletoeeprom();
      writecolorselecttoeeprom(); 
      if (row == 0) menuoption = 10;
      if (row == 1) menuoption = 11;
      if (row == 2) menuoption = 12;
      if (row == 3) menuoption = 13;
      if (row == 4) menuoption = 14;
      if (row == 5) menuoption = 15;
      row = 0;
      mainmenurow = 0;
     }
  }
  if (mainmenurow == 2) {
    if (button == 1) {
      rowselect3[row] = 0;
      row--;
    }
    if (button == 3) {
      rowselect3[row] = 0;
      row++;
    }
    if (row < 0) row = 6;
    if (row > 6) row = 0;
    rowselect3[row] = 1;
    if (button == 5 && row < 6) {
      blinkenable[row]++;
      if (blinkenable[row] > 1) blinkenable[row] = 0;
      writeblinkenabletoeeprom();
    }
  }
  if (mainmenurow == 3) {
    if (button == 1) {
      rowselect4[row] = 0;
      row--;
    }
    if (button == 3) {
      rowselect4[row] = 0;
      row++;
    }
    if (row < 0) row = 6;
    if (row > 6) row = 0;
    rowselect4[row] = 1; 
    if (button == 5) {
      colorselect[row]++;
      if (colorselect[row] > 1) colorselect[row] = 0;  
      writecolorselecttoeeprom();
    }
  }
  
  OSD_write_to_screen("Main menu",10,1,0,0);
  OSD_write_to_screen("Text1:",2,2,0,0);
  OSD_write_to_screen("Text2:",2,4,0,0);
  OSD_write_to_screen("Text3:",2,6,0,0);
  OSD_write_to_screen("Text4:",2,8,0,0);
  OSD_write_to_screen("Text5:",2,10,0,0);
  OSD_write_to_screen("Text6:",2,12,0,0);
  if (textenable[0]== 0) OSD_write_to_screen("off",8,2,0,rowselect1[0]);
  if (textenable[0]== 1) OSD_write_to_screen("on ",8,2,0,rowselect1[0]);
  if (textenable[1]== 0) OSD_write_to_screen("off",8,4,0,rowselect1[1]);
  if (textenable[1]== 1) OSD_write_to_screen("on ",8,4,0,rowselect1[1]);
  if (textenable[2]== 0) OSD_write_to_screen("off",8,6,0,rowselect1[2]);
  if (textenable[2]== 1) OSD_write_to_screen("on ",8,6,0,rowselect1[2]);
  if (textenable[3]== 0) OSD_write_to_screen("off",8,8,0,rowselect1[3]);
  if (textenable[3]== 1) OSD_write_to_screen("on ",8,8,0,rowselect1[3]);
  if (textenable[4]== 0) OSD_write_to_screen("off",8,10,0,rowselect1[4]);
  if (textenable[4]== 1) OSD_write_to_screen("on ",8,10,0,rowselect1[4]);
  if (textenable[5]== 0) OSD_write_to_screen("off",8,12,0,rowselect1[5]);
  if (textenable[5]== 1) OSD_write_to_screen("on ",8,12,0,rowselect1[5]);

  OSD_write_to_screen("edit",12,2,0,rowselect2[0]);
  OSD_write_to_screen("edit",12,4,0,rowselect2[1]);
  OSD_write_to_screen("edit",12,6,0,rowselect2[2]);
  OSD_write_to_screen("edit",12,8,0,rowselect2[3]);
  OSD_write_to_screen("edit",12,10,0,rowselect2[4]);
  OSD_write_to_screen("edit",12,12,0,rowselect2[5]);

  OSD_write_to_screen("blink",17,2,blinkenable[0],rowselect3[0]);
  OSD_write_to_screen("blink",17,4,blinkenable[1],rowselect3[1]);
  OSD_write_to_screen("blink",17,6,blinkenable[2],rowselect3[2]);
  OSD_write_to_screen("blink",17,8,blinkenable[3],rowselect3[3]);
  OSD_write_to_screen("blink",17,10,blinkenable[4],rowselect3[4]);
  OSD_write_to_screen("blink",17,12,blinkenable[5],rowselect3[5]);
  
  if (colorselect[0]== 0) OSD_write_to_screen("white",23,2,0,rowselect4[0]);
  if (colorselect[0]== 1) OSD_write_to_screen("black",23,2,0,rowselect4[0]);
  if (colorselect[1]== 0) OSD_write_to_screen("white",23,4,0,rowselect4[1]);
  if (colorselect[1]== 1) OSD_write_to_screen("black",23,4,0,rowselect4[1]);
  if (colorselect[2]== 0) OSD_write_to_screen("white",23,6,0,rowselect4[2]);
  if (colorselect[2]== 1) OSD_write_to_screen("black",23,6,0,rowselect4[2]);
  if (colorselect[3]== 0) OSD_write_to_screen("white",23,8,0,rowselect4[3]);
  if (colorselect[3]== 1) OSD_write_to_screen("black",23,8,0,rowselect4[3]);
  if (colorselect[4]== 0) OSD_write_to_screen("white",23,10,0,rowselect4[4]);
  if (colorselect[4]== 1) OSD_write_to_screen("black",23,10,0,rowselect4[4]);
  if (colorselect[5]== 0) OSD_write_to_screen("white",23,12,0,rowselect4[5]);
  if (colorselect[5]== 1) OSD_write_to_screen("black",23,12,0,rowselect4[5]);

  if (mainmenurow == 0) OSD_write_to_screen("Back",2,14,0,rowselect1[6]);
  if (mainmenurow == 1) OSD_write_to_screen("Back",2,14,0,rowselect2[6]);
  if (mainmenurow == 2) OSD_write_to_screen("Back",2,14,0,rowselect3[6]);
  if (mainmenurow == 3) OSD_write_to_screen("Back",2,14,0,rowselect4[6]);
  if (button == 5 && row == 6) {
    rowselect1[6] = 0;
    rowselect2[6] = 0;
    rowselect3[6] = 0;
    rowselect4[6] = 0;
    colorselect[6] = 0;
    textenable[6] = 0;
    mainmenurow = 0;
    row = 0;
    button = 0;
    writetextenabletoeeprom(); 
    writeblinkenabletoeeprom();
    writecolorselecttoeeprom(); 
    OSD_Clear();
    menuoption = 0;
  }
  if (menuoption != 1) OSD_Clear();
  delay(100);
}
 
void edittext() {
 
} 

void edittext0() {
  OSD_write_to_screen("Edit text 1",2,1,0,0);
  if (button == 1) text0[editxpos]++;
  if (button == 3) text0[editxpos]--;
  if (text0[editxpos] < 0) text0[editxpos] = 73;
  if (text0[editxpos] > 73) text0[editxpos] = 0;
  if (button == 4) editxpos --;
  if (button == 2) editxpos ++;
  if (editxpos < 0) editxpos = 24;
  if (editxpos > 24) editxpos = 0;
  OSD_write_to_screen("                           ",0,4,0,0);
  OSD_write_to_screen("v",editxpos + 2,4,0,0);
  for (int x = 0; x < 25; x++) { 
    OSD_write_to_screen(availablecharacters[text0[x]],x + 2,5,0,0);
  }
  
  if (button == 5) {
    button = 0;
    writetext0toeeprom();
    OSD_Clear();
    textnumber = 0;
    menuoption = 20;
  }
  delay(100);
}

void edittext1() {
    OSD_write_to_screen("Edit text 2",2,1,0,0);
  if (button == 1) text1[editxpos]++;
  if (button == 3) text1[editxpos]--;
  if (text1[editxpos] < 0) text1[editxpos] = 73;
  if (text1[editxpos] > 73) text1[editxpos] = 0;
  if (button == 4) editxpos --;
  if (button == 2) editxpos ++;
  if (editxpos < 0) editxpos = 24;
  if (editxpos > 24) editxpos = 0;
  OSD_write_to_screen("                           ",0,4,0,0);
  OSD_write_to_screen("v",editxpos + 2,4,0,0);
  for (int x = 0; x < 25; x++) { 
    OSD_write_to_screen(availablecharacters[text1[x]],x + 2,5,0,0);
  }
  
  if (button == 5) {
    button = 0;
    writetext1toeeprom();
    OSD_Clear();
    textnumber = 1;
    menuoption = 20;
  }
  delay(100);
}
void edittext2() {
    OSD_write_to_screen("Edit text 3",2,1,0,0);
  if (button == 1) text2[editxpos]++;
  if (button == 3) text2[editxpos]--;
  if (text2[editxpos] < 0) text2[editxpos] = 73;
  if (text2[editxpos] > 73) text2[editxpos] = 0;
  if (button == 4) editxpos --;
  if (button == 2) editxpos ++;
  if (editxpos < 0) editxpos = 24;
  if (editxpos > 24) editxpos = 0;
  OSD_write_to_screen("                           ",0,4,0,0);
  OSD_write_to_screen("v",editxpos + 2,4,0,0);
  for (int x = 0; x < 25; x++) { 
    OSD_write_to_screen(availablecharacters[text2[x]],x + 2,5,0,0);
  }
  
  if (button == 5) {
    button = 0;
    writetext2toeeprom();
    OSD_Clear();
    textnumber = 2;
    menuoption = 20;
  }
  delay(100);
}
void edittext3() {
    OSD_write_to_screen("Edit text 4",2,1,0,0);
  if (button == 1) text3[editxpos]++;
  if (button == 3) text3[editxpos]--;
  if (text3[editxpos] < 0) text3[editxpos] = 73;
  if (text3[editxpos] > 73) text3[editxpos] = 0;
  if (button == 4) editxpos --;
  if (button == 2) editxpos ++;
  if (editxpos < 0) editxpos = 24;
  if (editxpos > 24) editxpos = 0;
  OSD_write_to_screen("                           ",0,4,0,0);
  OSD_write_to_screen("v",editxpos + 2,4,0,0);
  for (int x = 0; x < 25; x++) { 
    OSD_write_to_screen(availablecharacters[text3[x]],x + 2,5,0,0);
  }
  
  if (button == 5) {
    button = 0;
    writetext3toeeprom();
    OSD_Clear();
    textnumber = 3;
    menuoption = 20;
  }
  delay(100);
}
void edittext4() {
    OSD_write_to_screen("Edit text 5",2,1,0,0);
  if (button == 1) text4[editxpos]++;
  if (button == 3) text4[editxpos]--;
  if (text4[editxpos] < 0) text4[editxpos] = 73;
  if (text4[editxpos] > 73) text4[editxpos] = 0;
  if (button == 4) editxpos --;
  if (button == 2) editxpos ++;
  if (editxpos < 0) editxpos = 24;
  if (editxpos > 24) editxpos = 0;
  OSD_write_to_screen("                           ",0,4,0,0);
  OSD_write_to_screen("v",editxpos + 2,4,0,0);
  for (int x = 0; x < 25; x++) { 
    OSD_write_to_screen(availablecharacters[text4[x]],x + 2,5,0,0);
  }
  
  if (button == 5) {
    button = 0;
    writetext4toeeprom();
    OSD_Clear();
    textnumber = 4;
    menuoption = 20;
  }
  delay(100);
}
void edittext5() {
    OSD_write_to_screen("Edit text 6",2,1,0,0);
  if (button == 1) text5[editxpos]++;
  if (button == 3) text5[editxpos]--;
  if (text5[editxpos] < 0) text5[editxpos] = 73;
  if (text5[editxpos] > 73) text5[editxpos] = 0;
  if (button == 4) editxpos --;
  if (button == 2) editxpos ++;
  if (editxpos < 0) editxpos = 24;
  if (editxpos > 24) editxpos = 0;
  OSD_write_to_screen("                           ",0,4,0,0);
  OSD_write_to_screen("v",editxpos + 2,4,0,0);
  for (int x = 0; x < 25; x++) { 
    OSD_write_to_screen(availablecharacters[text5[x]],x + 2,5,0,0);
  }
  
  if (button == 5) {
    button = 0;
    writetext5toeeprom();
    OSD_Clear();
    textnumber = 5;
    menuoption = 20;
  }
  delay(100);
}

void movecursor() {
  Serial.println(button);
  if (button > 0) {
    OSD_Clear();
    Serial.println("clear");
  }
  if (button == 2) xpos[textnumber]++;
  if (button == 4) xpos[textnumber]--;
  if (button == 3) ypos[textnumber]++;
  if (button == 1) ypos[textnumber]--;
  if (xpos[textnumber] < 0) xpos[textnumber] = 26;
  if (xpos[textnumber] > 26) xpos[textnumber] = 0;
  if (ypos[textnumber] < 0) ypos[textnumber] = 14;
  if (ypos[textnumber] > 14) ypos[textnumber] = 0; 
  for (int x = 0; x < 25; x++) { 
    if (textnumber == 0)  OSD_write_to_screen(availablecharacters[text0[x]],xpos[textnumber] + x,ypos[textnumber],0,0);
    if (textnumber == 1)  OSD_write_to_screen(availablecharacters[text1[x]],xpos[textnumber] + x,ypos[textnumber],0,0);
    if (textnumber == 2)  OSD_write_to_screen(availablecharacters[text2[x]],xpos[textnumber] + x,ypos[textnumber],0,0);
    if (textnumber == 3)  OSD_write_to_screen(availablecharacters[text3[x]],xpos[textnumber] + x,ypos[textnumber],0,0);
    if (textnumber == 4)  OSD_write_to_screen(availablecharacters[text4[x]],xpos[textnumber] + x,ypos[textnumber],0,0);
    if (textnumber == 5)  OSD_write_to_screen(availablecharacters[text5[x]],xpos[textnumber] + x,ypos[textnumber],0,0);
  }
  if (button == 5) {
    button = 0;
    OSD_Clear();
    writexpostoeeprom();
    writeypostoeeprom();
    menuoption = 0;
  }
  delay(100);
}

void setup() {
  Serial.begin(9600);
  byte spi_junk;                        
  int x;
  int i;
  pinMode(MAX7456RESET,OUTPUT);
  digitalWrite(MAX7456RESET,HIGH); 
  pinMode(MAX7456SELECT,OUTPUT);
  digitalWrite(MAX7456SELECT,HIGH);  		
  pinMode(DATAOUT, OUTPUT);
  pinMode(DATAIN, INPUT);
  pinMode(SPICLOCK,OUTPUT);
  SPCR = (1<<SPE)|(1<<MSTR);
  spi_junk=SPSR;
  spi_junk=SPDR;
  delay(250);
  digitalWrite(MAX7456SELECT,LOW);
  spi_transfer(VM0_reg);
  spi_transfer(MAX7456_RESET);
  digitalWrite(MAX7456SELECT,HIGH);
  delay(500);		
  digitalWrite(MAX7456SELECT,LOW);
  for (x = 0; x < MAX_screen_rows; x++) {
    spi_transfer(x + 0x10);
    spi_transfer(WHITE_level_90);
  }
  spi_transfer(VM0_reg);
  spi_transfer(VERTICAL_SYNC_NEXT_VSYNC|OSD_ENABLE|VIDEO_MODE_PAL);	    	   
  digitalWrite(MAX7456SELECT,HIGH);
  delay(100);
  eepromcheck();
  readtext0fromeeprom();
  readtext1fromeeprom();
  readtext2fromeeprom();
  readtext3fromeeprom();
  readtext4fromeeprom();
  readtext5fromeeprom();
  readtextenablefromeeprom();
  readblinkenablefromeeprom();
  readcolorselectfromeeprom();	
  readxposfromeeprom();
  readyposfromeeprom();
  readloopxposfromeeprom();		     			    		    
  OSD_Clear();
}  

void loop() {
  readbuttons();
  menu();
}
